program info;

uses
    sysutils,
    classes,
    cmpTypes;

var
   quelle     : tfilestream;
   zheader    : TZHeader;
   ztable     : TZTable;
   ZTableData : TZTableData;
   i          : integer;
   prozent    : extended;

begin
     writeln('ZLib Archiv Information v1.03');
     writeln('');
     if ParamCount = 0 then
     begin
          writeln('Parameter: info <Archiv>');
          writeln('');
          halt;
     end;
     writeln(format('info %s',[paramstr(1)]));
     writeln('');
     quelle := tfilestream.create(paramstr(1), fmOpenRead);

     quelle.readbuffer(zheader, sizeof(zheader));
     writeln('id = "', zheader.id, '"');
     writeln(format('table offset = %xh', [zheader.tableoffset]));
     writeln('');

     quelle.seek(zheader.tableoffset, soFromBeginning);
     quelle.readbuffer(ztable, sizeof(ztable));
     writeln('compressed files = ', ztable.count);
     writeln('');
     writeln('file table');

     for i := 1 to ztable.count do
     begin
          quelle.readbuffer(ZTableData, sizeof(ZTableData));
          writeln(ZTableData.filename);
          writeln(format('  offset = %d (%xh)', [ZTableData.OffSet,ZTableData.OffSet]));
          writeln(format('  original size = %d (%xh)', [ZTableData.CRC,ZTableData.CRC]));
          writeln(format('  compressed size = %d (%xh)', [ZTableData.Size,ZTableData.Size]));
          prozent := (ZTableData.Size / ZTableData.CRC) * 100;
          writeln(format('  compress ratio = %2.1f%%', [prozent]));
     end;

     quelle.destroy;
end.
