unit ztInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons;

type
  Tztfrm_Info = class(TForm)
    btOk: TSpeedButton;
    ListBox: TListBox;
    btSave: TSpeedButton;
    OpenDialog: TOpenDialog;
    SaveDialog: TSaveDialog;
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure btSaveClick(Sender: TObject);
    procedure btOkClick(Sender: TObject);
  private
    fName : String;
  public
  end;

var
  ztfrm_Info: Tztfrm_Info;

implementation

uses cmpTypes;

{$R *.DFM}

procedure Tztfrm_Info.FormShow(Sender: TObject);
var
   quelle     : tfilestream;
   zheader    : TZHeader;
   ztable     : TZTable;
   ZTableData : TZTableData;
   i          : integer;
   prozent    : extended;
begin
     if fName <> '' then
     begin
          ListBox.Items.Add('ZLib Archiv Information v1.04');
          ListBox.Items.Add('');
          ListBox.Items.Add(format('Info %s',[fName]));
          ListBox.Items.Add('');
          quelle := tfilestream.create(fName, fmOpenRead);
          quelle.readbuffer(zheader, sizeof(zheader));
          ListBox.Items.Add('id = "' + zheader.id + '"');
          ListBox.Items.Add(format('table offset = %xh', [zheader.tableoffset]));
          ListBox.Items.Add('');
          quelle.seek(zheader.tableoffset, soFromBeginning);
          quelle.readbuffer(ztable, sizeof(ztable));
          ListBox.Items.Add('compressed files = ' + IntToStr(ztable.count));
          ListBox.Items.Add('');
          ListBox.Items.Add('file table');
          for i := 1 to ztable.count do
          begin
               quelle.readbuffer(ZTableData, sizeof(ZTableData));
               ListBox.Items.Add(ZTableData.filename);
               ListBox.Items.Add(format('  offset = %d (%xh)', [ZTableData.OffSet,ZTableData.OffSet]));
               ListBox.Items.Add(format('  original size = %d (%xh)', [ZTableData.CRC,ZTableData.CRC]));
               ListBox.Items.Add(format('  compressed size = %d (%xh)', [ZTableData.Size,ZTableData.Size]));
               prozent := (ZTableData.Size / ZTableData.CRC) * 100;
               ListBox.Items.Add(format('  compress ratio = %2.1f%%', [prozent]));
          end;
          quelle.destroy;
     end;
end;

procedure Tztfrm_Info.FormCreate(Sender: TObject);
begin
     OpenDialog.InitialDir := ExtractFileDir(Application.ExeName);
     if OpenDialog.Execute then
        fName := OpenDialog.FileName
     else
         fName := '';
end;

procedure Tztfrm_Info.btSaveClick(Sender: TObject);
begin
     if SaveDialog.Execute then
        ListBox.Items.SaveToFile(SaveDialog.FileName + '.txt');
end;

procedure Tztfrm_Info.btOkClick(Sender: TObject);
begin
     ModalResult := mrOk;
end;

end.
